﻿using System;
using System.Collections;
using System.Data;
using System.IO;
using System.Xml;
using System.Xml.Schema;
using System.Text;

namespace Common
{
    public class XMLValidator
    {
        static private void ValidationHandler(object sender, ValidationEventArgs args)
        {
            errorMessages = String.Format("{0}{1}Line:{2} Column:{3} Message: {4}",
                errorMessages,
                String.IsNullOrEmpty(errorMessages) ? String.Empty : Environment.NewLine,
                args.Exception.LineNumber,
                args.Exception.LinePosition,
                args.Message);
        }

        /// <summary>
        /// returns String.Empty if the xml validates and the validation error message
        /// otherwise
        /// </summary>
        /// <param name="strXMLDoc"></param>
        /// <returns></returns>
        static public string Validate(string strXMLDoc)
        {
            errorMessages = String.Empty;

            XmlReaderSettings validationSettings = new XmlReaderSettings();
            validationSettings.Schemas.Add(null, new XmlTextReader(getXsdStream()));
            validationSettings.ValidationType = ValidationType.Schema;
            validationSettings.ValidationEventHandler += new ValidationEventHandler(ValidationHandler);
            XmlReader xmlToValidate = XmlReader.Create(new StringReader(strXMLDoc), validationSettings);

            while (xmlToValidate.Read()) { }

            return errorMessages;
        }

        static private Stream getXsdStream()
        {
            return Util.GetResourceStream("XmlInputFileSchema.xsd");
        }
        // Validation Error Message
        static private string errorMessages = String.Empty;
    }
}